/*
 * Functions for calculating basis transformation matrices, etc.
 * 
 * Robert Johansson <robert@riken.jp>
 *
 * $Id: basis_transform.h,v 1.1.1.1 2008-09-03 09:36:41 rob Exp $
 */

#ifndef BASIS_TRANSFORM_H
#define BASIS_TRANSFORM_H

#include <gsl/gsl_matrix.h>

#include "quantum_system.h"
#include "param.h"

//typedef double (*ho_w_func_t)(double t, solver_param *sp);

gsl_matrix_complex *basis_transform(quantum_system *qs, solver_param *param, int n, ho_w_func_t ho_w_cb, double t);
gsl_matrix_complex *basis_transform_derivative(quantum_system *qs, solver_param *param, int n, ho_w_func_t ho_w_cb, double t);


#endif

