/*
 * Functions for generating hamiltonians in matrix form. 
 * 
 * 
 * Robert Johansson <robert@riken.jp>
 *
 * $Id: hamiltonian.h,v 1.3 2008-09-11 10:00:57 rob Exp $
 */

#ifndef HAMILTONIAN_H
#define HAMILTONIAN_H

#include <gsl/gsl_matrix.h>
#include "param.h"

typedef  gsl_matrix_complex*(*hamiltonian_func_real_t)(quantum_system *qs, solver_param *param);

gsl_matrix_complex *hamiltonian_nTLS(quantum_system *qs, solver_param *param);
int hamiltonian_t(gsl_matrix_complex *H_t, gsl_matrix_complex *H0, gsl_matrix_complex *H1, double t, solver_param *p);
gsl_matrix_complex *hamiltonian_drive(quantum_system *qs, solver_param *param);
gsl_matrix_complex *hamiltonian_2ho(quantum_system *qs, solver_param *param);
gsl_matrix_complex *hamiltonian_2ho_drive(quantum_system *qs, solver_param *param);

gsl_matrix_complex *hamiltonian_q2ho(quantum_system *qs, solver_param *param);
gsl_matrix_complex *hamiltonian_q2ho_drive(quantum_system *qs, solver_param *param);

gsl_matrix_complex *hamiltonian_qho(quantum_system *qs, solver_param *param);
gsl_matrix_complex *hamiltonian_qho_drive(quantum_system *qs, solver_param *param);

gsl_matrix_complex *hamiltonian_3ls_ho(quantum_system *qs, solver_param *param);
gsl_matrix_complex *hamiltonian_3ls_ho_drive(quantum_system *qs, solver_param *param);

gsl_matrix_complex *hamiltonian_ho(quantum_system *qs, solver_param *param);
gsl_matrix_complex *hamiltonian_ho_drive(quantum_system *qs, solver_param *param);

gsl_matrix_complex *hamiltonian_dicke(quantum_system *qs, solver_param *param);

#endif

