/*
 * A collection of various functions. Printing, saving to file, etc. 
 * 
 * 
 * Robert Johansson <robert@riken.jp>
 *
 * $Id: misc.h,v 1.1.1.1 2008-09-03 09:36:41 rob Exp $
 */

#ifndef MISC_H
#define MISC_H

#include <gsl/gsl_matrix.h>

void misc_matrix_print(gsl_matrix *m, int n);
void misc_matrix_complex_print(gsl_matrix_complex *m, int n);
void misc_matrix_complex_print_real(gsl_matrix_complex *m, int n);
void misc_matrix_complex_print_imag(gsl_matrix_complex *m, int n);
int misc_file_row_add(const char *filename, const char *row);
	
int misc_matrix_write(char *filename, gsl_matrix_complex *m, int n);
int misc_matrix_read(char *filename, gsl_matrix_complex *m, int n);
int misc_matrix_diag_write(char *filename, gsl_matrix_complex *m, int n, char *msg);
int misc_matrix_diag_read(char *filename, gsl_matrix_complex *m, int n);
int misc_matrix_diag_real_write(char *filename, gsl_matrix_complex *m, int n, char *msg);
int misc_matrix_diag_real_read(char *filename, gsl_matrix_complex *m, int n);


#endif
