/*
 * Functions for generating matrix representations of quantum operators.
 * 
 * 
 * Robert Johansson <robert@riken.jp>
 *
 * $Id: operators.h,v 1.3 2008-09-11 10:00:57 rob Exp $
 */

#ifndef OPERATORS_H
#define OPERATORS_H

#include <gsl/gsl_matrix.h>

gsl_matrix_complex *operator_sigma_z(quantum_system *qs, int n);
gsl_matrix_complex *operator_sigma_x(quantum_system *qs, int n);
gsl_matrix_complex *operator_sigma_y(quantum_system *qs, int n);

gsl_matrix_complex *operator_3ls_sigma_z(quantum_system *qs, int n);
gsl_matrix_complex *operator_3ls_sigma_x(quantum_system *qs, int n);

gsl_matrix_complex *operator_J_minus(quantum_system *qs, int n, double jj);
gsl_matrix_complex *operator_J_plus (quantum_system *qs, int n, double jj);
gsl_matrix_complex *operator_Jz     (quantum_system *qs, int n, double jj);



gsl_matrix_complex *operator_unit(quantum_system *qs, int n);

gsl_matrix_complex *operator_ho_lowering(quantum_system *qs, int n, int offset);
gsl_matrix_complex *operator_ho_raising(quantum_system *qs, int n, int offset);
gsl_matrix_complex *operator_ho_N(quantum_system *qs, int n, int offset);
gsl_complex operator_trace(gsl_matrix_complex *op);

gsl_matrix_complex *operator_project(quantum_system *qs, int n, int si, int sj);
	


#endif

